routes/web.php
<?php

use App\Http\Controllers\ProfileController;
use App\Http\Controllers\MessagesController;
use App\Http\Controllers\PagesController;
use App\Http\Controllers\UsersController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

Route::get('test', function() {

    return \App\Models\User::with('mensajes')->get();
});

Route::resource('usuarios', UsersController::class);

Route::get('/', 'App\Http\Controllers\MessagesController@create')->name('home');
Route::resource('mensajes', MessagesController::class);

Route::get('mensajes-exportar', 'App\Http\Controllers\MessagesController@export')->name('mensajes.export');
Route::get('mensajes-importar', 'App\Http\Controllers\MessagesController@import')->name('mensajes.import');
Route::post('mensajes-importar', 'App\Http\Controllers\MessagesController@import')->name('mensajes.import');


Route::get('documentacion', 'App\Http\Controllers\PagesController@docu')->name('docu');

// Route::get('/dashboard', function () {
//     return view('dashboard');
// })->middleware(['auth', 'verified'])->name('dashboard');

Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
});

require __DIR__.'/auth.php';

resources/views/mensajes/edit.blade.php
@extends('layouts.app')

@section('contenido')

<h2 class="mt-10 bg-gradient-to-r from-indigo-400 to-green-600 bg-clip-text 
text-center text-4xl font-extrabold text-transparent sm:text-xl"> Edicion de mensaje</h2>

 <form action="{{ route('mensajes.update',$mensaje->id)}}" method="POST" class="text-center">
    {!!method_field('PUT')!!}
    {!! csrf_field() !!}
      <label class="font-boldr" for="nombre">Nombre </label>
      <input class="block mx-auto" type="text" name="nombre" value="{{ old('nombre') }}">
      <span class="error">{{$errors->first('nombre')}}</span>
      

      <label class="font-bold" for="email">Email </label>
      <input class="block mx-auto" type="email" name="email" value="{{ old('email') }}">
      <span class="error"> {{$errors->first('email') }}</span>                   
      

      <label class="font-bold" for="mensaje">Mensaje</label>
      <textarea class="block mx-auto" style="resize:none;" name="mensaje" cols="30" rows="5" value="{{ old('mensaje') }}"></textarea>
      <span class="error">{{$errors->first('mensaje')}}</span>                           

      <button type="submit" class="mt-5 block rounded bg-blue-500 px-3 py-1 text-white mx-auto">Enviar</button>
 </form>

@endsection

resources/views/mensajes/export.blade.php
@if ($mensajes->count())

    <table>    
        <thead>
            <tr>
                <th>Nombre</th>
                <th>Email</th>
                <th>Mensaje</th>                
            </tr>
        </thead>

        <tbody>       

            @foreach ($mensajes as $m)
                <tr>
                    <td>{{ $m->nombre }}</td>
                    <td>{{ $m->email }}</td>
                    <td>{{ $m->mensaje }}</td>                    
                </tr>
                        
            @endforeach
        
        </tbody>
    </table>

@else
    <table style="width:100%; border:1px solid">
        <tbody>
            <tr> No hay mensajes cargados </tr>
        </tbody>
    </table>

@endif

resources/views/mensajes/index.blade.php
@extends('layouts.app')

@section('contenido')

@if (Session()->has('success'))
    <h3> {{ Session('success') }}</h3>
@endif

@if (Session()->has('errors'))
    <h3> {{ Session('errors') }}</h3>
@endif

<h1 class="mt-10 bg-gradient-to-r from-indigo-400 to-green-600 bg-clip-text 
text-center text-4xl font-extrabold text-transparent sm:text-xl">Todos los mensajes</h1>

<div>
     <a href="{{url('mensajes-exportar')}}">Exportar</a> 
     {{-- <a href="{{url('mensajes-importar')}}">Importar</a>       --}}
</div>

<div>
    <form action="{{url('mensajes-importar')}}" method="post" enctype="multipart/form-data" >
        {!! csrf_field() !!}
        <input type="file" name="file">
        <button type="submit">Importar</button>   
    </form>

</div>

@if ($mensajes->count())

    <table class="w-full table-auto border-collapse border border-slate-400 text-center">    
        <thead class="text-sm">
            <tr>
                <th class="border border-slate-300">Nombre</th>
                <th class="border border-slate-300">Email</th>
                <th class="border border-slate-300">Mensaje</th>
                <th class="border border-slate-300">Acciones</th>
            </tr>
        </thead>

        <tbody>       

            @foreach ($mensajes as $m)
                <tr>
                    <td class="border border-slate-300">{{ $m->nombre }}</td>
                    <td class="border border-slate-300">{{ $m->email }}</td>
                    <td class="border border-slate-300">{{ $m->mensaje }}</td>
                    <td class="border border-slate-300"> 
                        <a href="{{route('mensajes.show',$m->id)}}">👁</a>
                        <a href="{{route('mensajes.edit',$m->id)}}">📗</a>
                        <form action="{{route('mensajes.destroy',$m->id)}}" method="POST" style="display:inline">
                            {!! csrf_field() !!}
                            {!! method_field('DELETE') !!}
                            <button type="submit"> ❌ </button>
                        </form>                    

                    </td>
                </tr>
                        
            @endforeach
        
        </tbody>
    </table>

@else
    <table style="width:100%; border:1px solid">
        <tbody>
            <tr> No hay mensajes cargados </tr>
        </tbody>
    </table>

@endif

@endsection

resources/views/mensajes/show.blade.php
@extends('layouts.app')

@section('contenido')

<h1> Mensaje de {{ $mensaje->nombre }} - {{ $mensaje->email }}</h1>
<p> <b> {{ $mensaje->mensaje }} </b></p>


@endsection